CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000                                'Note Clock Speed for your setup!!

VAR
   long rightwstick
   long rightw
   long leftwstick
   long leftw
   long rightbase
   long rightb
   long rightarm
   long righta
   long leftbase
   long leftb
   long leftarm
   long lefta
   long pusher
   long push

VAR
long    Stack[150]   
OBJ
   servo  : "PropBOE Servos"
   RC     : "RCTIME"
   pst    : "Parallax Serial Terminal Plus"
   system : "Propeller Board of Education" 
   time   : "Timing"

PUB main
    cognew(Read_RCTIME,@Stack)                          ''Start reading RCTIME as a group in the background ; 1 cog
    repeat
      Calculations

      rightdrive
      leftdrive
      
      rightsidebase
      rightsidearm
      
      leftsidebase
      lefttsidearm
      
      thepusher                               

PUB Read_RCTIME                                         ''Use one cog to read ALL inputs and run in background
    repeat
      RC.RCTIME( 0, 1, @rightwstick )
      RC.RCTIME( 1, 1, @leftwstick)
      RC.RCTIME( 2, 1, @rightbase )
      RC.RCTIME( 3, 1, @rightarm )
      RC.RCTIME( 4, 1, @leftbase )
      RC.RCTIME( 5, 1, @leftarm )
      RC.RCTIME( 6, 1, @pusher )

PUB Calculations                                        ''Do calculations ; no extra cog required                              
    rightw := ((rightwstick/8) - 180)
    leftw  := ((leftwstick/8) - 180)
    rightb := ((rightbase/8) - 180)
    righta := ((rightarm/8) - 180)
    rightb := ((leftbase/8) - 180)
    lefta  := ((leftarm/8) - 180)
    push   := ((pusher/8) - 180)
  
PUB rightdrive
    servo.Set(7, rightw)                                      
    servo.Set(8, rightw)

PUB leftdrive
    servo.Set(9, leftw)                                      
    servo.Set(10, leftw)                          
                            
PUB rightsidebase
    servo.Set(11, rightb)                                      

PUB rightsidearm
    servo.Set(12, righta)       

PUB leftsidebase
    servo.Set(13, leftb)                                      

PUB lefttsidearm
    servo.Set(14, lefta)   

PUB thepusher
    servo.Set(15, push)                                         
   